/* This program attempts to do "Multithreading" by using stack-switch
 *  mechanism.
 *              copyright sarnath.k, final year CSE, PEC,India
 *               date : 8/11/1999.
 *  Idea invented by: sarnath.k and sriram.v of final year CSE .
 *  Pondicherry Engineering College.
 *  Free for distribution ... Except that this header goes with
 *  it . Any modifications are invited . please feel free to mail me at
 *  "sarnath@lycos.com or intel386@usa.net" for getting more details about
 *  this if u need.
 */

#include <dos.h>
#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include<graphics.h>
#include <conio.h>

int gd=9,gm=2;

char far *scr=(char far *)0xb8000000;
char far *dos_busy,dummy;
unsigned Thread_busy;

enum Threadstate {FIRST_RUN,READY,RUNNING,ZOMBIE};

typedef struct
{
	unsigned ss;
	unsigned sp;
}Frozen_thread_context;

typedef struct Thread_info
{
	unsigned Thread_id;
	Frozen_thread_context  vital;
	enum Threadstate state;
	void  (*fn)();  /*function address for
			  first run.unused for
			  next scheduling..*/
	struct Thread_info    *prev;
	struct Thread_info    *next;
	char     far   *Thread_stack;
	void     far   *Saved_stack;
}Thread_table;

unsigned  current_id,dont_interrupt=0;
Thread_table *init,*t,*current;
unsigned id=0;

int  nomore=0;
int  thorough,ticks=0,index=0;

char far (stack1[4000]);     /* stack for 1st thread */
char far (stack2[4000]);     /* stack for 2nd thread */
char far (stack3[4000]);     /* stack for 3rd thread */
char far (stack4[4000]);     /* stack for 4th thread */


void interrupt (*old8)();


Thread_table *schedule(Thread_table *t);

void interrupt new8()
{
	(*old8)();
	asm cli

	if (!Thread_busy && *dos_busy == 0)  /* Oh no ! DOS isn't reentrant . If this isn't the case Thread switches would be fast & efficient */
	{
		t=init;
		thorough=0;

/*check if all threads have died out */
/* if so raise signal , nomore =1 => breaks while loop in main*/

		do
		{
			if (t->state != ZOMBIE)
			break;
			t=t->next;
			thorough=1;
		}while (t != init);

		if (t==init && thorough)  /*init &&  thorough => one full loop around the queue */
			{
				nomore=1;   /* main waits for this event to happen */
				/*   return by the stack
				     through which we entered.
				*/
				_SS=FP_SEG(init->Saved_stack);
				_SP=FP_OFF(init->Saved_stack);
				asm sti
				return;     /* return 2 the while loop in the main */
			}

/* start examining the current process. time for scheduling next */
/* select next thread */

		t=current;
		switch (t->state)
		{

			case ZOMBIE:
					  current=schedule(current);
					  break;

			case FIRST_RUN:
					current_id=t->Thread_id;
					t->state=RUNNING;
					t->Saved_stack=MK_FP(_SS,_SP);
					_SS=FP_SEG(t->Thread_stack);
					_SP=FP_OFF(t->Thread_stack)+3999;
					current=t;  /* added just for essence */
					asm sti
					(*t->fn)();
					Thread_busy++;
					t=init;
					index=0;
					while(index++ != current_id)
						t=t->next;
					t->state=ZOMBIE;
					asm sti
					Thread_busy--;
					while(1);
/* Wait for next time interrupt
* That will break this loop by
* scheduling some other thread
*/

			case RUNNING:   /*oh sorry ! mr. current thread.
					u'll be given a chance later*/
					current->state=READY;
					current->vital.ss=_SS; /* capture the context */
					current->vital.sp=_SP;
					current=schedule(current);
					break;

			case READY:
					current_id=current->Thread_id;
					_SS=current->vital.ss;
					_SP=current->vital.sp;
					current->state=RUNNING;
					break;

default :
				puts("unable to schedule..This condn should not arise !!");
				break;
		}

/* switch to next thread */

		t=current;
		switch (current->state)
		{
			case FIRST_RUN:
					current_id=t->Thread_id;
					t->state=RUNNING;
					t->Saved_stack=MK_FP(_SS,_SP);
					_SS=FP_SEG(t->Thread_stack);
					_SP=FP_OFF(t->Thread_stack)+3999;
					current=t;  /* added just for essence */
					asm sti
					(*t->fn)();
					Thread_busy++;
					t=init;
					index=0;
					while(index++ != current_id)
						t=t->next;
					t->state=ZOMBIE;
					Thread_busy--;
					asm sti
					while(1);

			case RUNNING:
					current_id=current->Thread_id;
					break;
			case READY:
					current_id=current->Thread_id;
					_SS=current->vital.ss;
					_SP=current->vital.sp;
					current->state=RUNNING;
					break;

		}
	}

	current_id=current->Thread_id;
	asm sti
}

Thread_table *schedule(Thread_table *t)
{
	Thread_table *cur=t;

	/* This scheduler is fairly simple. It's perfect
	* almost all times. It selects the thread waiting
	* for CPU service next  to the current . That's it. (RR)
	* if at all such a one is there.No prio... no stuff
	* of optimizin for performance..
*/

	t=t->next;
	do
	{
		if (t->state == READY  ||  t->state==FIRST_RUN || t->state==RUNNING)
		break;
		t=t->next;
	}while(t != cur);
	cur=t;
	return cur;
}

void first_thread();
void second_thread();
void third_thread();
void fourth_thread();

void  create_thread(void (*fn)(),char far *stack)
{
	Thread_table *p,*prev;

	if (init == NULL)
	{
		init=(Thread_table *)malloc(sizeof(Thread_table));
		if (init == NULL)
			{
				perror("Insuff.. memory....");
				exit(0);
			}
		init->prev=NULL;
		init->next=init;
		init->fn=fn;
		init->state=FIRST_RUN;
		init->Thread_stack=stack;
		init->Thread_id=id++;
		return ;
	}

	p=init;
	while(p->next != init) p=p->next;
		prev=p;

	/* allocate a new slot */
	p->next=(Thread_table *)malloc(sizeof(Thread_table));
	if (p== NULL)
	{
		perror("Insuff.. memory....");
		exit(0);
	}
	p=p->next;
	p->prev=prev;
	p->next=init;         /* let tail point to head something circular */
	prev->next=p;
	p->fn=fn;
	p->state=FIRST_RUN;
	p->Thread_stack=stack;
	p->Thread_id=id++;
	return ;
}       /* End of create thread */


unsigned inter_thread=0,i,j;

void main()
{
	union REGS regs;
	struct SREGS sregs;

	regs.h.ah=0x34;
	int86x(0x21,&regs,&regs,&sregs);
	dos_busy=(char far *)MK_FP(sregs.es,regs.x.bx);

	clrscr();
	printf ("\nDear user, This Program attempts to do multi-threading in");
	printf (" DOS.");
	printf ("\nPress ESC once for each thread (totally 4 thread will b executed) to terminate Program");
	printf ("\nPressing ESC terminates the currently executing thread");
	printf ("\nPress any key 2 continue ");
	if (!getch()) getch();

	create_thread(first_thread,stack1);
	create_thread(second_thread,stack2);
	create_thread(third_thread,stack3);
	create_thread(fourth_thread,stack4);
	current=init;
	old8=getvect(0x08);
	asm cli
	setvect(0x08,new8);
	asm sti
	while(!nomore);
	setvect(0x08,old8);
	return;
}



void first_thread()  /*don't use any local variables */
{
	while(1)
	{
		puts("First Thread 					         1");

	       /* Oh ! These puts & printf's !!! They make dos busy always.
		*so more printf's and scanf will make the
		*rate of thread switch very slow !!!That's the ill fate of
		*DOS users!!
		*/

		i++;
		j++;
		i++;
		i=j;
		j=i;
		i+=34;
		j=i;
		delay(2);

		/*These nonsense codes are added so that dos is not busy always
		 * writing to console.These are lively breeding
		 * grounds of task - switch occureneces.
		 */

		if (kbhit())
		{
			if (getch()==27)
				break;
		}
	}
}

void second_thread()  /*don't use any local variables */
{
	while(1)
	{
		puts("Second Thread          				         2");
		i++;
		j++;
		i++;
		i=j;
		j=i;
		i+=34;
		j=i;
		delay(2);
		if (kbhit())
		{
			if (getch() == 27) break;
		}
	}
}


void third_thread()  /*don't use any local variables */
{
	while(1)
	{
		puts("Third thread                                                  3");
		i++;
		j++;
		i++;
		i=j;
		j=i;
		i+=34;
		j=i;
		delay(2);
		if (kbhit())
		{
			if (getch() == 27) break;
		}
	}
}

void fourth_thread()  /*don't use any local variables */
{
	while(1)
	{
		puts("Fourth Thread                                                 4");
		i++;
		j++;
		i++;
		i=j;
		j=i;
		i+=34;
		j=i;
		delay(2);  /*give an oppotunity for a task - switch*/
		if (kbhit())
		{
			if (getch() == 27) break;
		}
	}
}
